/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.15
        Device            :  PIC16F1619
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set input1 aliases
#define input1_TRIS               TRISAbits.TRISA0
#define input1_LAT                LATAbits.LATA0
#define input1_PORT               PORTAbits.RA0
#define input1_WPU                WPUAbits.WPUA0
#define input1_OD                ODCONAbits.ODA0
#define input1_ANS                ANSELAbits.ANSA0
#define input1_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define input1_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define input1_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define input1_GetValue()           PORTAbits.RA0
#define input1_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define input1_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define input1_SetPullup()      do { WPUAbits.WPUA0 = 1; } while(0)
#define input1_ResetPullup()    do { WPUAbits.WPUA0 = 0; } while(0)
#define input1_SetPushPull()    do { ODCONAbits.ODA0 = 1; } while(0)
#define input1_SetOpenDrain()   do { ODCONAbits.ODA0 = 0; } while(0)
#define input1_SetAnalogMode()  do { ANSELAbits.ANSA0 = 1; } while(0)
#define input1_SetDigitalMode() do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set outputA aliases
#define outputA_TRIS               TRISAbits.TRISA2
#define outputA_LAT                LATAbits.LATA2
#define outputA_PORT               PORTAbits.RA2
#define outputA_WPU                WPUAbits.WPUA2
#define outputA_OD                ODCONAbits.ODA2
#define outputA_ANS                ANSELAbits.ANSA2
#define outputA_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define outputA_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define outputA_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define outputA_GetValue()           PORTAbits.RA2
#define outputA_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define outputA_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define outputA_SetPullup()      do { WPUAbits.WPUA2 = 1; } while(0)
#define outputA_ResetPullup()    do { WPUAbits.WPUA2 = 0; } while(0)
#define outputA_SetPushPull()    do { ODCONAbits.ODA2 = 1; } while(0)
#define outputA_SetOpenDrain()   do { ODCONAbits.ODA2 = 0; } while(0)
#define outputA_SetAnalogMode()  do { ANSELAbits.ANSA2 = 1; } while(0)
#define outputA_SetDigitalMode() do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set WAKESW aliases
#define WAKESW_TRIS               TRISAbits.TRISA4
#define WAKESW_LAT                LATAbits.LATA4
#define WAKESW_PORT               PORTAbits.RA4
#define WAKESW_WPU                WPUAbits.WPUA4
#define WAKESW_OD                ODCONAbits.ODA4
#define WAKESW_ANS                ANSELAbits.ANSA4
#define WAKESW_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define WAKESW_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define WAKESW_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define WAKESW_GetValue()           PORTAbits.RA4
#define WAKESW_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define WAKESW_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define WAKESW_SetPullup()      do { WPUAbits.WPUA4 = 1; } while(0)
#define WAKESW_ResetPullup()    do { WPUAbits.WPUA4 = 0; } while(0)
#define WAKESW_SetPushPull()    do { ODCONAbits.ODA4 = 1; } while(0)
#define WAKESW_SetOpenDrain()   do { ODCONAbits.ODA4 = 0; } while(0)
#define WAKESW_SetAnalogMode()  do { ANSELAbits.ANSA4 = 1; } while(0)
#define WAKESW_SetDigitalMode() do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set outputB aliases
#define outputB_TRIS               TRISAbits.TRISA5
#define outputB_LAT                LATAbits.LATA5
#define outputB_PORT               PORTAbits.RA5
#define outputB_WPU                WPUAbits.WPUA5
#define outputB_OD                ODCONAbits.ODA5
#define outputB_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define outputB_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define outputB_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define outputB_GetValue()           PORTAbits.RA5
#define outputB_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define outputB_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define outputB_SetPullup()      do { WPUAbits.WPUA5 = 1; } while(0)
#define outputB_ResetPullup()    do { WPUAbits.WPUA5 = 0; } while(0)
#define outputB_SetPushPull()    do { ODCONAbits.ODA5 = 1; } while(0)
#define outputB_SetOpenDrain()   do { ODCONAbits.ODA5 = 0; } while(0)

// get/set RB5 procedures
#define RB5_SetHigh()    do { LATBbits.LATB5 = 1; } while(0)
#define RB5_SetLow()   do { LATBbits.LATB5 = 0; } while(0)
#define RB5_Toggle()   do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define RB5_GetValue()         PORTBbits.RB5
#define RB5_SetDigitalInput()   do { TRISBbits.TRISB5 = 1; } while(0)
#define RB5_SetDigitalOutput()  do { TRISBbits.TRISB5 = 0; } while(0)
#define RB5_SetPullup()     do { WPUBbits.WPUB5 = 1; } while(0)
#define RB5_ResetPullup()   do { WPUBbits.WPUB5 = 0; } while(0)
#define RB5_SetAnalogMode() do { ANSELBbits.ANSB5 = 1; } while(0)
#define RB5_SetDigitalMode()do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set RB7 procedures
#define RB7_SetHigh()    do { LATBbits.LATB7 = 1; } while(0)
#define RB7_SetLow()   do { LATBbits.LATB7 = 0; } while(0)
#define RB7_Toggle()   do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define RB7_GetValue()         PORTBbits.RB7
#define RB7_SetDigitalInput()   do { TRISBbits.TRISB7 = 1; } while(0)
#define RB7_SetDigitalOutput()  do { TRISBbits.TRISB7 = 0; } while(0)
#define RB7_SetPullup()     do { WPUBbits.WPUB7 = 1; } while(0)
#define RB7_ResetPullup()   do { WPUBbits.WPUB7 = 0; } while(0)
#define RB7_SetAnalogMode() do { ANSELBbits.ANSB7 = 1; } while(0)
#define RB7_SetDigitalMode()do { ANSELBbits.ANSB7 = 0; } while(0)

// get/set POT aliases
#define POT_TRIS               TRISCbits.TRISC0
#define POT_LAT                LATCbits.LATC0
#define POT_PORT               PORTCbits.RC0
#define POT_WPU                WPUCbits.WPUC0
#define POT_OD                ODCONCbits.ODC0
#define POT_ANS                ANSELCbits.ANSC0
#define POT_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define POT_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define POT_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define POT_GetValue()           PORTCbits.RC0
#define POT_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define POT_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define POT_SetPullup()      do { WPUCbits.WPUC0 = 1; } while(0)
#define POT_ResetPullup()    do { WPUCbits.WPUC0 = 0; } while(0)
#define POT_SetPushPull()    do { ODCONCbits.ODC0 = 1; } while(0)
#define POT_SetOpenDrain()   do { ODCONCbits.ODC0 = 0; } while(0)
#define POT_SetAnalogMode()  do { ANSELCbits.ANSC0 = 1; } while(0)
#define POT_SetDigitalMode() do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set WAKEHW aliases
#define WAKEHW_TRIS               TRISCbits.TRISC3
#define WAKEHW_LAT                LATCbits.LATC3
#define WAKEHW_PORT               PORTCbits.RC3
#define WAKEHW_WPU                WPUCbits.WPUC3
#define WAKEHW_OD                ODCONCbits.ODC3
#define WAKEHW_ANS                ANSELCbits.ANSC3
#define WAKEHW_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define WAKEHW_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define WAKEHW_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define WAKEHW_GetValue()           PORTCbits.RC3
#define WAKEHW_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define WAKEHW_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define WAKEHW_SetPullup()      do { WPUCbits.WPUC3 = 1; } while(0)
#define WAKEHW_ResetPullup()    do { WPUCbits.WPUC3 = 0; } while(0)
#define WAKEHW_SetPushPull()    do { ODCONCbits.ODC3 = 1; } while(0)
#define WAKEHW_SetOpenDrain()   do { ODCONCbits.ODC3 = 0; } while(0)
#define WAKEHW_SetAnalogMode()  do { ANSELCbits.ANSC3 = 1; } while(0)
#define WAKEHW_SetDigitalMode() do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set input2 aliases
#define input2_TRIS               TRISCbits.TRISC4
#define input2_LAT                LATCbits.LATC4
#define input2_PORT               PORTCbits.RC4
#define input2_WPU                WPUCbits.WPUC4
#define input2_OD                ODCONCbits.ODC4
#define input2_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define input2_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define input2_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define input2_GetValue()           PORTCbits.RC4
#define input2_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define input2_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define input2_SetPullup()      do { WPUCbits.WPUC4 = 1; } while(0)
#define input2_ResetPullup()    do { WPUCbits.WPUC4 = 0; } while(0)
#define input2_SetPushPull()    do { ODCONCbits.ODC4 = 1; } while(0)
#define input2_SetOpenDrain()   do { ODCONCbits.ODC4 = 0; } while(0)

// get/set CMD aliases
#define CMD_TRIS               TRISCbits.TRISC5
#define CMD_LAT                LATCbits.LATC5
#define CMD_PORT               PORTCbits.RC5
#define CMD_WPU                WPUCbits.WPUC5
#define CMD_OD                ODCONCbits.ODC5
#define CMD_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define CMD_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define CMD_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define CMD_GetValue()           PORTCbits.RC5
#define CMD_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define CMD_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define CMD_SetPullup()      do { WPUCbits.WPUC5 = 1; } while(0)
#define CMD_ResetPullup()    do { WPUCbits.WPUC5 = 0; } while(0)
#define CMD_SetPushPull()    do { ODCONCbits.ODC5 = 1; } while(0)
#define CMD_SetOpenDrain()   do { ODCONCbits.ODC5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/